//****************************************************************************
// ArrayUtil.java
//
// 
//
//
//**************************************************************************** 
import java.io.*;
import java.util.*;

public class ArrayUtil {

   
   // CONSTRUCTOR
   private ArrayUtil( ) {
   }

   //---------------------------------------------------------------------
   // printArray( double [][][] )
   //
   //
   //---------------------------------------------------------------------
   public static void printArray(double arr[][][]){

       int lenDim1 = arr.length;
       int lenDim2 = arr[0].length;
       int lenDim3 = arr[0][0].length;


       System.out.println("=========================================");
       for (int i=0;i<lenDim1;i++) {
          System.out.println("\n  Slice " + i);
          for (int j=0;j<lenDim2;j++) {
             for (int k=0;k<lenDim3;k++) {
                 System.out.print(arr[i][j][k]+ "  ");
             }
             System.out.println();
          }
       }
       System.out.println("=========================================\n\n");
    }


   //---------------------------------------------------------------------
   // printArray( double [][][], int dim1, int dim2, int dim3 )
   //
   // - print subarray
   //---------------------------------------------------------------------
   public static void printArray(double arr[][][], int dim1, int dim2, int dim3)
   {
       System.out.println("=========================================");
       for (int i=0;i<dim1;i++) {
          System.out.println("\n  Slice " + i);
          for (int j=0;j<dim2;j++) {
             for (int k=0;k<dim3;k++) {
                 System.out.print(arr[i][j][k]+ "  ");
             }
             System.out.println();
          }
       }
       System.out.println("=========================================\n\n");
    }

   //---------------------------------------------------------------------
   // printArray( double [][][] )
   //
   //
   //---------------------------------------------------------------------
   public static void printArray(double arr[]){
       int lenDim1 = arr.length;

       System.out.println("=========================================");
       for (int i=0;i<lenDim1;i++) {
           System.out.print(arr[i]+ "  ");
       }
       System.out.println("\n=========================================\n\n");
    }


   //---------------------------------------------------------------------
   // printArrayFormatted( double [][][] )
   //
   //
   //---------------------------------------------------------------------
   public static void printArrayFormatted(double arr[][][]){

       int lenDim1 = arr.length;
       int lenDim2 = arr[0].length;
       int lenDim3 = arr[0][0].length;


       System.out.println("=========================================");
       for (int i=0;i<lenDim1;i++) {
          System.out.println("\n  Slice " + i);
          for (int j=0;j<lenDim2;j++) {
             for (int k=0;k<lenDim3;k++) {
                 System.out.printf("%8.1f ",arr[i][j][k]);
             }
             System.out.println();
          }
       }
       System.out.println("=========================================\n\n");
    }



   //------------ copyArray(double [][][], double [][][]) -----------------
   //
   //  Assumes the dest can fit it
   //--------------------------------------------------------------------
    static void copyArray(double dest[][][], double src[][][]){


       int lenDim1 = src.length;
       int lenDim2 = src[0].length;
       int lenDim3 = src[0][0].length;

       //dest = new double[lenDim1][lenDim2][lenDim3];
       
       for (int i=0; i<lenDim1;i++){
          for (int j=0; j<lenDim2;j++){
             for (int k=0; k<lenDim3;k++){
                 dest[i][j][k] = src[i][j][k];
             }
          }
       }    
    }

     //------------ copyArray(double [][][], double [][][]) -----------------
   //
   //  Assumes the dest can fit it
   //--------------------------------------------------------------------
    static void copyArray(float dest[][][], float src[][][]){


       int lenDim1 = src.length;
       int lenDim2 = src[0].length;
       int lenDim3 = src[0][0].length;

       for (int i=0; i<lenDim1;i++){
          for (int j=0; j<lenDim2;j++){
             for (int k=0; k<lenDim3;k++){
                 dest[i][j][k] = src[i][j][k];
             }
          }
       }
    }

       //------------ copyArray(double [][][], double [][][]) -----------------
   //
   //  Assumes the dest can fit it
   //--------------------------------------------------------------------
    static void copyArray(double dest[], double src[]){

       int lenDim1 = src.length;

       for (int i=0; i<lenDim1;i++){
                 dest[i] = src[i];
       }
    }



    static void setDoubleArray(double arr[][][], double val){

       for (int i=0; i< arr.length;i++) {
           for (int j=0; j< arr[0].length; j++) {
               for (int k=0; k<arr[0][0].length; k++){
                   arr[i][j][k] = val;
               }
           }
       }
    }

    static void setFloatArray(float arr[][][], float val){

       for (int i=0; i< arr.length;i++) {
           for (int j=0; j< arr[0].length; j++) {
               for (int k=0; k<arr[0][0].length; k++){
                   arr[i][j][k] = val;
               }
           }
       }
    }

    
   //--------------------------------------------------------------------
   // main
   //
   //-------------------------------------------------------------------- 
    public static void main(String [ ] args) {

      double[][][] initArr = new double [4][4][4];

       double val=1.0f;
       for (int i=0; i<4;i++){
          for (int j=0; j<4;j++){
             for (int k=0; k<4;k++){
                initArr[i][j][k] = val++;
             }
          }
       }

       printArray(initArr);

       double[][][] arr2 = new double [4][4][4];
       copyArray(arr2, initArr);
       printArray(arr2);
    }
}



