//-------------------------------------------------------------------------
//  IndexValPair CLASS
//-------------------------------------------------------------------------
class IndexValPair implements Comparable {

     private int index;
     private double value;

     public IndexValPair(int ind, double val) {
         index = ind;
         value = val;
     }

     public double getValue() {
         return this.value;
     }

     public int getIndex() {
         return this.index;
     }

     public String toString() {
         return (" (" + index + ", " + value + ")");
     }

     public int compareTo(Object pair) throws ClassCastException {
         if (!(pair instanceof IndexValPair)) {
             throw new ClassCastException("A IndexValPair Object expected.");
         }

         // Return 0 for a match, -1 for less than and +1 for more then
         if (Math.abs(this.getValue()) == 
                               Math.abs((((IndexValPair) pair).getValue()))) 
         {
             return 0;
         } 
         else if (Math.abs( this.getValue()) 
                                     > Math.abs(((IndexValPair) pair).getValue())) 
         {
            return -1;
         } else {
             return 1;
         }
    }
 }