 //-------------------------------------------------------------------------
 //  LocValPair CLASS
 //-------------------------------------------------------------------------
 class LocValPair implements Comparable {

     private int xLoc, yLoc, zLoc;
     private double value;

     public LocValPair(int x, int y, int z, double val) {
         xLoc = x;
         yLoc = y;
         zLoc = z;
         value = val;
     }

     public double getValue() {
         return this.value;
     }

     public int getX() {
         return this.xLoc;
     }

     public int getY() {
         return this.yLoc;
     }

     public int getZ() {
         return this.zLoc;
     }

     public String toString() {
         return (" (" + xLoc + ", " + yLoc + ", " + zLoc + ") = " + value);
     }

     public int compareTo(Object pair) throws ClassCastException {
         if (!(pair instanceof LocValPair)) {
             throw new ClassCastException("A LocValPair Object expected.");
         }

         // Return 0 for a match, -1 for less than and +1 for more then
         if (Math.abs(this.getValue()) == 
                               Math.abs((((LocValPair) pair).getValue()))) 
         {
             return 0;
         } 
         else if (Math.abs( this.getValue()) 
                                     > Math.abs(((LocValPair) pair).getValue())) 
         {
            return -1;
         } else {
             return 1;
         }
    }
 }