/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Jon
 */
public class Partition {

    public Partition(){}
    
    static public void createPartitions( String filename, int numPartPerDim,
                                         boolean bigEndian)
    {
       FileUtil fu = new FileUtil();
       //System.out.println("Reading input file");
       float[][][] data = fu.readFloatDataFromFile(filename, bigEndian);
       //System.out.println("File read");

       int dim1=data.length;
       int dim2=data[0].length;
       int dim3=data[0][0].length;

      
       if ( (dim1%numPartPerDim != 0) || (dim2%numPartPerDim != 0)
          ||(dim3%numPartPerDim != 0) )
       {
          System.out.println(" dimensions of data don't divide evenly by "
                             + numPartPerDim);
          System.exit(0);
       }

       int incrDim1 =  dim1/numPartPerDim;
       int incrDim2 =  dim2/numPartPerDim;
       int incrDim3 =  dim3/numPartPerDim;

       System.out.println("incrDim1="+incrDim1
                        + "   incrDim2=" +incrDim2
                        + "   incrDim3=" + incrDim3);

       System.out.println("dim1="+dim1
                        + "   dim2=" +dim2
                        + "   dim3=" + dim3);

       int partNum=1;
       for (int i=0; i<dim1;i+=incrDim1) {
           System.out.println("i="+i);
           for (int j=0; j<dim2;j+=incrDim2) {
               
                for (int k=0; k<dim3;k+=incrDim3) {
                   
                    writePartition( i+"-"+j+"-"+k+".bin" , data, i, i+incrDim1,
                                   j, j+incrDim2, k, k+incrDim3, bigEndian);
                    partNum++;
                }
           }
       }
       
    }



    //------------------------------------------------------------------------
    // writePartition
    //
    // - Writes this partition to a file
    //
    //------------------------------------------------------------------------
    private static void writePartition(String filename, float[][][] data,
                                int i1, int i2, int j1, int j2, int k1, int k2,
                                boolean bigEndian)
    {
        int dim1=i2-i1;
        int dim2=j2-j1;
        int dim3=k2-k1;

        float [][][] arr = new float[dim1][dim2][dim3];
       
        // copy data over
        for (int i=i1; i<i2; i++) {
            for ( int j=j1; j<j2; j++) {
                for ( int k=k1; k<k2; k++) {
                   arr[i-i1][j-j1][k-k1] = data[i][j][k];
                }
            }
        }

        // write file
        FileUtil fu = new FileUtil();
        fu.writeDataToFile(filename, arr, bigEndian);
    }
}
